#include "bits/stdc++.h"
#include "testlib.h"

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define all(a) a.begin(), a.end()
#define pb push_back
using namespace std;


/// Actual code starts here
using ll = long long;
using ld = long double;


map<string, string> parse;

int num(string &s) {
    return stoi(s);
}

int sign(long long x) {
    if (x == 0) return 0;
    return (x < 0 ? -1 : 1);
}


template<class T>
T sq(T a) {
    return a * a;
}

#define vec point
#define vecld pointld

struct point {
    ll x = 0, y = 0;

    point() : x(0), y(0) {
    }

    point(ll x, ll y) : x(x), y(y) {
    }

    point operator+(const point &other) const {
        return point({x + other.x, y + other.y});
    }

    point operator-(const point &other) const {
        return point({x - other.x, y - other.y});
    }

    point operator*(const ll &delta) const {
        return point({x * delta, y * delta});
    }

    point operator/(const ll &delta) const {
        return point({x / delta, y / delta});
    }

    ll operator*(const point &other) const {
        return x * other.x + y * other.y;
    }


    ll operator^(const point &other) const {
        return x * other.y - y * other.x;
    }

    bool operator<(const point &other) const {
        if (sign(x - other.x) == 0) {
            return sign(y - other.y) < 0;
        } else {
            return sign(x - other.x) < 0;
        }
    }

    bool operator==(const point &other) const {
        return sign(x - other.x) == 0 && sign(y - other.y) == 0;
    }

    point perp() const {
        return point({-y, x});
    }

    long double len() const {
        return sqrtl(sq(x) + sq(y));
    }

    long long len2() const {
        return sq(x) + sq(y);
    }

    friend std::ostream &operator<<(std::ostream &os, const point &p) {
        os << "[x, y]: " << fixed << p.x << ' ' << p.y;
        return os;
    }
};

struct pointld {
    ld x = 0, y = 0;

    pointld(ld x_, ld y_) : x(x_), y(y_) {
    }

    pointld(point pt) : x(static_cast<long double>(pt.x)), y(static_cast<long double>(pt.y)) {
    }

    pointld perp() const {
        return pointld(-y, x);
    }

    ld len() const {
        return sqrtl(sq(x) + sq(y));
    }

};


class MyHashFunction {
public:
    size_t operator()(const point &t) const {
        return t.x + 34324728428 * t.y;
    }
};


vector<point> CreateBigHullPoints(int n, int c) {
    vector<point> points;
    vector<pair<int, int>> v;
    for (int x = 1; v.size() + 1 < n; ++x) {
        for (int y = 1; y <= x && v.size() + 1 < n; ++y) {
            if (gcd(x, y) != 1)
                continue;
            v.push_back({x, y});
        }
    }
    sort(v.begin(), v.end(), [&](pair<int, int> a, pair<int, int> b) {
        return a.first * b.second - a.second * b.first > 0;
    });
    reverse(v.begin(), v.end());
    int x = -c;
    int y = c / 2;
    points.push_back({x, y});
    for (auto i: v) {
        x += i.first;
        y -= i.second;
        points.push_back({x, y});
        err(points.size());
        ensure(y >= -c);
        ensure(x <= c);
    }
    while (points.size() < n) {
        points.push_back({rnd.next(-c, c), rnd.next(-c, c)});
    }
    return points;
}

ll dist(int x1, int y1, int x2, int y2) {
    return sq((ll) x1 - x2) + sq((ll) y1 - y2);
}

bool checkInCircle(int ox, int oy, int r, int x, int y) {
    return sq((ll) r) >= dist(ox, oy, x, y);
}

vector<point> CreateTorusPoints(int n, int c) {
    vector<point> points;
    // чтобы удобно было))
    ensure(c >= 10);

    int centerX = c / 2;
    int centerY = c / 2;
    int r1 = rnd.next(1, c / 2);
    int r2 = rnd.next(1, c / 2);

    // равные r1 == r2 - проблема?

    while (r1 == r2) {
        r1 = rnd.next(1, c / 2);
    }

    if (r1 > r2) {
        swap(r1, r2);
    }

    for (int i = 0; i < n; ++i) {
        while (true) {
            // cerr << "r1 = " << r1 << " r2 = " << r2 << endl;
            int x = rnd.next(0, r2);

            int ly = 0, ry = r1 + 1;
            while (ly < ry - 1) {
                int mid = ((long long) ly + ry) / 2;
                if (checkInCircle(centerX, centerY, r1, centerX + x, centerY + mid)) {
                    ly = mid;
                } else {
                    ry = mid;
                }
            }

            int L = ry;

            ly = 0, ry = r2 + 1;
            while (ly < ry - 1) {
                int mid = ((long long) ly + ry) / 2;
                if (checkInCircle(centerX, centerY, r2, centerX + x, centerY + mid)) {
                    ly = mid;
                } else {
                    ry = mid;
                }
            }

            int R = ly;

            // cerr << "L = " << L << " R = " << R << endl;

            // может так получиться что для данного x нет подходящих y в окружности
            if (L > R)
                continue;

            int y = rnd.next(L, R);

            if (rnd.next(1, 2) == 1) {
                x = -x;
            }

            if (rnd.next(1, 2) == 1) {
                y = -y;
            }

            points.push_back({centerX + x, centerY + y});
            break;
        }
    }
    return points;
}


bool cmp(const vec &a, const vec &b) {
    int s = sign(a ^ b);
    if (s > 0) return true;
    else if (s == 0) return a.len2() < b.len2();
    else return false;
}

bool cmp2(const pair<vec, int> &a, const pair<vec, int> &b) {
    int s = sign(a.first ^ b.first);
    if (s > 0) return true;
    else if (s == 0) return a.first.len2() < b.first.len2();
    else return false;
}


bool check_hull(vector<point> &hull, int mx) {
    for (auto &i: hull) {
        if (abs(i.x) > mx) return false;
        if (abs(i.y) > mx) return false;
    }
    int ok = 0;
    int n = hull.size();
    for (int i = 0; i < n; i++) {
        int j = (i + 1) % n;
        int j2 = (i + 2) % n;
        vec a = (hull[j] - hull[i]);
        vec b = (hull[j2] - hull[j]);
        if (sign(a ^ b) < 0) {
            ok |= 1;
        }
        if (sign(a ^ b) > 0) {
            ok |= 2;
        }
    }
    return ok != 3;
}


//
//bool on_segment(const point &a, const point &b, const point &c) {
//    if (a == c || b == c) return true;
//    if (a == b) return false;
//    return sign((c - a) ^ (b - a)) == 0 && sign((c - a) * (b - a)) == 1 && sign((c - b) * (a - b)) == 1;
//}

void build_convex_hull_from_points(vector<point> &hull, vector<point> &in_hull) {
    for (int i = 1; i < hull.size(); i++) {
        if (hull[i] < hull[0])
            swap(hull[i], hull[0]);
    }
    for (int i = 1; i < hull.size(); i++)
        hull[i] = hull[i] - hull[0];
    sort(hull.begin() + 1, hull.end(), cmp);

    for (int i = 1; i < hull.size(); i++)
        hull[i] = hull[i] + hull[0];

    vector<point> res_hull = {hull[0], hull[1]}, res_cent;
    for (int i = 2; i < hull.size(); i++) {
        while (res_hull.size() > 1 &&
               sign((res_hull.back() - res_hull[res_hull.size() - 2]) ^ (hull[i] - res_hull.back())) <= 0) {
            res_cent.push_back(res_hull.back());
            res_hull.pop_back();
        }
        res_hull.push_back(hull[i]);
    }
    hull = res_hull;
    in_hull = res_cent;
}

void build_convex_hull_from_points_with_line(vector<point> &hull, vector<point> &in_hull) {
    for (int i = 1; i < hull.size(); i++) {
        if (hull[i] < hull[0])
            swap(hull[i], hull[0]);
    }
    for (int i = 1; i < hull.size(); i++)
        hull[i] = hull[i] - hull[0];
    sort(hull.begin() + 1, hull.end(), cmp);

    for (int i = 1; i < hull.size(); i++)
        hull[i] = hull[i] + hull[0];

    deque<point> res_hull = {hull[0], hull[1]}, res_cent;
    while (res_hull.size() > 1 && res_hull.back() == res_hull[res_hull.size() - 2]) res_hull.pop_back();
    for (int i = 2; i < hull.size(); i++) {
        while (!res_hull.empty() && res_hull.back() == hull[i]) res_hull.pop_back();
        while (res_hull.size() > 1 && res_hull.back() == res_hull[res_hull.size() - 2]) res_hull.pop_back();
        while (res_hull.size() > 1 &&
               sign((res_hull.back() - res_hull[res_hull.size() - 2]) ^ (hull[i] - res_hull.back())) < 0) {
            res_cent.push_back(res_hull.back());
            res_hull.pop_back();
        }
        res_hull.push_back(hull[i]);
    }
    while (res_hull.size() > 1 && res_hull.back() == res_hull[res_hull.size() - 2]) res_hull.pop_back();
    while (res_hull.size() > 1 && res_hull.back() == res_hull.front()) res_hull.pop_front();
    hull.clear();
    in_hull.clear();
    for (auto i: res_hull) hull.push_back(i);
    for (auto i: res_cent) in_hull.push_back(i);
}

void sorting(vector<pair<vec, int>> &vectors) {
    vector<pair<vec, int>> up, dw;
    for (auto &v: vectors) {
        if (v.first.y > 0 || (v.first.y >= 0 && v.first.x >= 0)) {
            up.push_back(v);
        } else {
            dw.push_back(v);
        }
    }

    sort(up.begin(), up.end(), cmp2);
    sort(dw.begin(), dw.end(), cmp2);
    for (auto &i: dw) {
        up.push_back(i);
    }
    vectors = up;
}

vector<point> CreateGridPoints(int n, int c, int x, int y) {
    vector<point> points;
    set<int> used;
    vector<int> myX;
    for (int i = 0; i < x; ++i) {
        int now = rnd.next(1, c);
        while (used.count(now)) {
            now = rnd.next(1, c);
        }
        used.insert(now);
        myX.push_back(now);
    }
    used.clear();
    vector<int> myY;
    for (int i = 0; i < y; ++i) {
        int now = rnd.next(1, c);
        while (used.count(now)) {
            now = rnd.next(1, c);
        }
        used.insert(now);
        myY.push_back(now);
    }
    for (auto xx: myX) {
        for (auto yy: myY) {
            points.push_back({xx, yy});
        }
    }

    while (points.size() < n) {
        int xx = rnd.next(1, c);
        int yy = rnd.next(1, c);
        points.push_back({xx, yy});
    }
    return points;
}

vector<point> CreateTrianglesPoints(int n, int c, int staticTriangle = 0) {
    vector<point> points;
    ensure(c >= 10);
    int cnt = n / 3;
    vector<int> x, y;
    for (int i = 0; i < cnt; ++i) {
        if (staticTriangle == 0) {
            y.push_back(rnd.next(1, c / 2 - 1));
            y.push_back(rnd.next(c / 2 + 1, c));
            x.push_back(rnd.next(1, c / 2 - 1));
            x.push_back(rnd.next(c / 2 + 1, c));
        } else {
            y.push_back(1 + i);
            y.push_back(c - i);
            x.push_back(1 + i);
            x.push_back(c - i);
        }
    }
    sort(x.begin(), x.end());
    sort(y.begin(), y.end());

    for (int i = 0; i < cnt; ++i) {
        points.push_back({x[i], y[i]});
        points.push_back({x[x.size() - 1 - i], y[i]});
        points.push_back({c / 2, y[y.size() - 1 - i]});
    }

    for (int i = points.size(); i < n; ++i) {
        int x = rnd.next(1, c);
        int y = rnd.next(1, c);
        points.push_back({x, y});
    }
    return points;
}

vector<point> CreateRandomPoints(int n, int c, int sx = 0, int sy = 0) {
    vector<point> points(n);
    for (auto &[x, y]: points) {
        x = rnd.next(-c, c);
        y = rnd.next(-c, c);
    }
    return points;
}

vector<point> CreatePolygonPoints(int n, int c, int centralPoint = 0) {
    static const int BUBEN = 10;
    vector<point> points;
    vector<pair<int, int>> v;
    for (int x = 1; 4 * (v.size() + 1) <= n; ++x) {
        for (int y = 1; y <= x && 4 * (v.size() + 1) <= n; ++y) {
            if (gcd(x, y) != 1)
                continue;
            v.push_back({x, y});
        }
    }

    sort(v.begin(), v.end(), [&](pair<int, int> a, pair<int, int> b) {
        return a.first * b.second - a.second * b.first > 0;
    });

    int x = c / 2 + c / BUBEN;
    int y = c / BUBEN;
    points.push_back({x, y});
    for (auto i: v) {
        x += i.first;
        y += i.second;
        points.push_back({x, y});
    }

    int sz = points.size();
    for (int i = sz - 1; i >= 0; --i) {
        points.push_back({points[i].x, c - points[i].y});
    }

    sz = points.size();
    for (int i = 0; i < sz; ++i) {
        points.push_back({c - points[i].x, points[i].y});
    }

    if (centralPoint) {
        int x = rnd.next(c / 2 - 100, c / 2 + 100);
        int y = rnd.next(c / 2 - 100, c / 2 + 100);
        reverse(points.begin(), points.end());
        points.push_back({x, y});
        reverse(points.begin(), points.end());
    }

    shuffle(all(points));
    if (points.size() > n) {
        points.resize(n);
    }

    return points;
}

vector<point> gen_regular_polygon(int n, double radius, int centralPoint = 0) {
    vector<point> res;
    cout.precision(20);
    const ld pi = acosl(-1);
    for (int i = 0; i < n; i++) {
        double angle = 2 * pi * i / n;
        res.push_back(point(static_cast<ll>(radius * std::cos(angle)), static_cast<ll>(radius * std::sin(angle))));
    }
    return res;
}


void fix_points(vector<point> &hull, point c, vector<point> &in) {
    vector<pair<vec, int>> pts;
    for (auto i: hull) {
        pts.push_back({i - c, 1});
    }
    for (auto i: in) {
        if (i == c) continue;
        pts.push_back({i - c, 0});
    }
    sorting(pts);
    int n = pts.size();
    vector<point> res;
    vector<bool> oks(n, true);
    for (int i = 0; i < n;) {
        int j = i;
        int ok = 0;
        while (j < n + i && sign(pts[j % n].first ^ pts[i].first) == 0) {
            ok |= pts[j % n].second;
            j++;
        }
        if (ok) {
            for (int k = i; k < j; k++)
                oks[k % n] = false;
        }
        i = j;
    }
    for (int i = 0; i < n; i++)
        if (pts[i].second == 0 && oks[i])
            res.push_back(pts[i].first + c);
    in = res;
}


struct query {
    point pt;
    char type;
};

bool in_hull(vector<point> &hull, point pt) {
    int ok = 0;
    for (int i = 0; i < hull.size(); i++) {
        vec a = hull[(i + 1) % hull.size()] - hull[i];
        if (sign(a ^ (pt - hull[i])) == 1) {
            ok |= 1;
        } else if (sign(a ^ (pt - hull[i])) == -1) {
            ok |= 2;
        } else {
            ok |= 3;
        }
    }
    return ok != 3;
}

bool in_triangle(point a, point b, point c, point fc) {
    vector<point> pt = {a, b, c};
    return in_hull(pt, fc);
}

void gen_internal_points(vector<point> &hull, vector<point> &in, int need_dif) {
    int iters = 0;
    set < point > unq;
    for (auto i: in)
        unq.insert(i);
    while (unq.size() < need_dif && iters < 2e6) {
        iters++;
        point a = hull[rnd.next(0, (int) hull.size() - 1)];
        point b = hull[rnd.next(0, (int) hull.size() - 1)];
        point c = hull[rnd.next(0, (int) hull.size() - 1)];
        if (a == b || b == c || a == c) continue;
//        if (b < a) swap(a, b);
//        if (c < a) swap(a, c);
        vec v = b - a;
        double len = v.len();
        ld delta = rnd.next(len);
        pointld d = {(ld) v.x / len * delta, (ld) v.y / len * delta};
        ld delta2 = rnd.next(len);
        pointld d2 = {(ld) v.x, (ld) v.y};
        d2 = d2.perp();
        if (rnd.next(1, 2) == 1) {
            d2.x *= -1;
            d2.y *= -1;
        }
        ld xx = d2.x / len;
        ld yy = d2.y / len;
        if (xx == 0) xx = 1;
        if (yy == 0) yy = 1;
        d2 = {xx * delta2, yy * delta2};
        point g = {(ll) (d.x + d2.x), (ll) (d.y + d2.y)};
        if (in_triangle(a, b, c, g) && !unq.count(g)) {
            in.push_back(g);
            unq.insert(g);
        }
    }
    in.clear();
    for (auto i: unq) {
        in.push_back(i);
    }
}

void gen_internal_points_each_part_center(point cent, vector<point> &hull, vector<point> &in) {
    set < point > unq;
    for (int i = 0; i < hull.size(); ++i) {
        point a = hull[i];
        point b = hull[(i + 1) % hull.size()];
        point c = cent;
        point d = a + b + c;
        d = d / 3;
        point res = {1488228, 1488228};
        for (int delta = -1; delta <= 1; delta++)
            for (int delta2 = -1; delta2 <= 1; delta2++) {
                point now = d;
                now.x += delta;
                now.y += delta2;
                if (in_triangle(a, b, c, now))
                    res = now;
            }
//        if (!in_triangle(a, b, c, res)) continue;
//        ensure(in_triangle(a, b, c, res));
        if (unq.find(res) == unq.end()) {
            unq.insert(res);
        }
    }
    in.clear();
    for (auto i: unq) {
        in.push_back(i);
    }
}

void gen_internal_points_each_part_center_cluster(point cent, vector<point> &hull, vector<point> &in) {
    set < point > unq;
    int max_cnt = num(parse["cluster_size"]);
    for (int i = 0; i < hull.size(); ++i) {
        point a = hull[i];
        point b = hull[(i + 1) % hull.size()];
        point c = cent;
        point d = a + b + c;
        d = d / 3;
        point res = {1488228, 1488228};
        int take = rnd.next(1, max_cnt);
        for (int it = 0; it < take; it++) {
            for (int delta = -10; delta <= 10; delta++)
                for (int delta2 = -10; delta2 <= 10; delta2++) {
                    point now = d;
                    now.x += delta;
                    now.y += delta2;
                    if (in_triangle(a, b, c, now) && !unq.count(now))
                        res = now;
                }
            ensuref(in_triangle(a, b, c, res), "res does not in triangle");
            unq.insert(res);
        }
    }
    in.clear();
    for (auto i: unq) {
        in.push_back(i);
    }
}


void gen_internal_points_for_grid(vector<point> &hull, vector<point> &in, int need_dif, int maxc) {
    int iters = 0;
    set < point > unq;
    for (auto i: in)
        unq.insert(i);
    while (unq.size() < need_dif && iters < 2e6) {
        iters++;
        point a = hull[rnd.next(0, (int) hull.size() - 1)];
        point b = hull[rnd.next(0, (int) hull.size() - 1)];
        point c = hull[rnd.next(0, (int) hull.size() - 1)];
        if (a == b || b == c || a == c) continue;
        point g = {rnd.next(0, maxc), rnd.next(0, maxc)};
        if (in_triangle(a, b, c, g) && !unq.count(g)) {
            unq.insert(g);
        }
    }
    in.clear();
    for (auto i: unq) {
        in.push_back(i);
    }
}


void gen_query_rand(vector<point> &in, vector<point> &before, vector<query> &qs, int m, int q) {
    shuffle(all(in));
    ensure(in.size() > m + 1);
    unordered_multiset<point, MyHashFunction> use;
    for (int i = 0; i < m; i++) {
        before.push_back(in.back());
        in.pop_back();
        use.insert(before.back());
    }
    int del_chance = 3;
    if (parse.count("chance"))
        del_chance = num(parse["chance"]);
    for (int i = 0; i < q; i++) {
        if ((in.empty() || rnd.next(1, del_chance) == (del_chance + 1) / 2) && !use.empty()) {
            qs.push_back({*use.begin(), '-'});
            use.erase(use.begin());
            in.push_back(qs.back().pt);
        } else {
            qs.push_back({in.back(), '+'});
            use.insert(in.back());
            in.pop_back();
        }
    }
}

void gen_go_all(vector<point> &in, int p, vector<query> &qs) {
    if (p == in.size()) {
        return;
    }
    qs.push_back({in[p], '+'});
    gen_go_all(in, p + 1, qs);
    qs.push_back({in[p], '-'});
    gen_go_all(in, p + 1, qs);
}

void gen_query_all(vector<point> &in, vector<point> &before, vector<query> &qs, int m) {
    ensure(in.size() > m);
    ensure(in.size() < 19);
    shuffle(all(in));
    unordered_multiset<point, MyHashFunction> use;
    for (int i = 0; i < m; i++) {
        before.push_back(in.back());
        in.pop_back();
        use.insert(before.back());
    }
    gen_go_all(in, 0, qs);
}

struct vec_info {
    vec v;
    int type; // from triangle or from points
    int id;
};

bool cmp_vec_info(const vec_info &a, const vec_info &b) {
    int s = sign(a.v ^ b.v);
    if (s > 0) return true;
    else if (s == 0) return a.v.len2() < b.v.len2();
    else return false;
}

void sorting(vector<vec_info> &vectors) {
    vector<vec_info> up, dw;
    for (auto &v: vectors) {
        if (v.v.y > 0 || (v.v.y >= 0 && v.v.x >= 0)) {
            up.push_back(v);
        } else {
            dw.push_back(v);
        }
    }

    sort(up.begin(), up.end(), cmp_vec_info);
    sort(dw.begin(), dw.end(), cmp_vec_info);
    for (auto &i: dw) {
        up.push_back(i);
    }
    vectors = up;
}


vector<string> bob;
vector<string> alice;

const int NS = 1e4 + 5;
int dp[NS], mex[NS];

int get_mex(int n) {
    for (int i = 0; i < n; i++) {
        while (true) {
            if (mex[i] >= n || mex[i] < 0) break;
            if (mex[mex[i]] == mex[i]) break;
            swap(mex[i], mex[mex[i]]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (mex[i] != i)
            return i;
    }
    return n;
}


vector<int> lens[256];

void calc_dp() {
    dp[0] = 0;
    dp[1] = 1;
    for (int len = 2; len < NS; len++) {
        int pt = 0;
        mex[pt++] = dp[len - 1];
        mex[pt++] = dp[len - 2];
        for (int cut = 1; cut + 2 < len; cut++) {
            mex[pt++] = (dp[cut] ^ dp[len - cut - 2]);
        }
        dp[len] = get_mex(pt);
        lens[dp[len]].push_back(len);
    }
}

int dp2[NS][256];


void dfs(int v, int xr, string &now) {
    if (!bob.empty() && bob.size() * bob[0].size() > 1e7) return;
    if (v == 1) {
        bob.push_back(now);
        return;
    }
    for (int take = 0; take < 32; take++) {
        if (lens[take].empty()) continue;
        int iters = 0;
        for (auto len: lens[take]) {
            if (iters > 7) break;
            if (v - len - 1 >= 1 && dp2[v - len - 1][xr ^ take]) {
                iters++;
                for (int j = v - len - 1; j < v - 1; j++) now[j - 1] = '1';
                dfs(v - len - 1, xr ^ take, now);
                for (int j = v - len - 1; j < v - 1; j++) now[j - 1] = '0';
            } else if (v - len - 1 < 1) {
                break;
            }
        }
    }
}

void gen_bob_sequence(int n) {
    calc_dp();
    dp2[1][0] = 1;
    for (int i = 1; i <= n; i++) {
//        err(i);
        for (int xr = 0; xr < 32; xr++) {
            if (!dp2[i][xr]) continue;
            for (int take = 0; take < 32; take++) {
                if (lens[take].empty()) continue;
                int iters = 0, iter2 = 0;
                for (auto len: lens[take]) {
                    if (iters > 5) break;
                    if (i + (len + 1) - 1 <= n) {
                        dp2[i + len + 1][xr ^ take] |= 1;
                        iters++;
                    } else {
                        break;
                    }
                }
            }
        }
    }
    string now(n, '0');
    dfs(n + 1, 0, now);
//    err(228);
}


void gen_query_random_smart(point c, vector<point> &hull, vector<point> &in, vector<point> &before, vector<query> &qs,
                            int q) { // only for mode each_one and m = 0
    gen_bob_sequence(hull.size());
    vector<vec_info> v;
    for (int i = 0; i < hull.size(); i++) {
        v.push_back({hull[i] - c, 0, i});
    }
    sorting(v);
    for (int i = 0; i < hull.size(); i++) {
        v[i].id = i;
    }

    for (int i = 0; i < in.size(); i++) {
        v.push_back({in[i] - c, 1, i});
    }

    sorting(v);

    vector<int> triangle_id_m(in.size(), -1);

    int z = v.size();
    int l = 0;

    while (v[l].type != 0) l++;
    vector<point> chose(hull.size(), {1488228, 1488228});
    while (l < z) {
        int r = (l + 1) % z;
        while (v[r].type != 0) {
            r++;
            if (r == z) r = 0;
        }

        int rep = (l + 1) % z;
        while (rep != r) {
            point a = (v[l].v + c);
            point b = (v[rep].v + c);
            point d = (v[r].v + c);
            if (sign((d - a) ^ (b - a)) > 0) {
                if (v[rep].type == 1) {
                    triangle_id_m[v[rep].id] = v[l].id;
                    chose[v[l].id] = v[rep].v + c;
                } else {
                    throw std::runtime_error("invalid gen_query_random_smart sorting points to triangles");
                }
            }
            rep++;
            if (rep == z) rep = 0;
        }

        if (l > r) break;
        l = r;
    }
    char st = '0';
    if (parse.count("start_mode"))
        st = parse["start_mode"][0];
    if (st == '1') {
        for (int i = 0; i < hull.size(); i++)
            if (chose[i].x != 1488228 || chose[i].y != 1488228)
                before.push_back(chose[i]);
    }
    string last(hull.size(), st);
    int mx = 1 << 30;
    if (parse.count("period"))
        mx = num(parse["period"]);
    while (qs.size() < q) {
        string now = last;
        if (rnd.next(0, 1) == 1 && bob.size() > 1) { // is bob_sequence
            now = bob[rnd.next(0, (int) bob.size() - 1)];
        } else {
            for (int i = 0; i < now.size();) {
                int rem = now.size() - i;
                rem = min(rem, mx);
                int len = rnd.next(1, rem);
                int value = rnd.next(0, 1);
                for (int j = i; j < i + len; j++)
                    now[j] = '0' + value;
                i += len;
            }
        }
        if (now == last) continue;
        for (int i = 0; i < now.size() && qs.size() < q; i++) {
            if (now[i] != last[i]) {
                if (now[i] == '1') {
                    qs.push_back({chose[i], '+'});
                } else {
                    qs.push_back({chose[i], '-'});
                }
            }
        }
        last = now;
    }
}

void gen_query_random_smart_cluster(point c, vector<point> &hull, vector<point> &in, vector<point> &before,
                                    vector<query> &qs,
                                    int q) { // only for mode each_one and m = 0
    gen_bob_sequence(hull.size());
    vector<vec_info> v;
    for (int i = 0; i < hull.size(); i++) {
        v.push_back({hull[i] - c, 0, i});
    }
    sorting(v);
    for (int i = 0; i < hull.size(); i++) {
        v[i].id = i;
    }

    for (int i = 0; i < in.size(); i++) {
        v.push_back({in[i] - c, 1, i});
    }

    sorting(v);

    vector<int> triangle_id_m(in.size(), -1);

    int z = v.size();
    int l = 0;

    while (v[l].type != 0) l++;
    vector<vector<point>> chose(hull.size());
    while (l < z) {
        int r = (l + 1) % z;
        while (v[r].type != 0) {
            r++;
            if (r == z) r = 0;
        }

        int rep = (l + 1) % z;
        while (rep != r) {
            point a = (v[l].v + c);
            point b = (v[rep].v + c);
            point d = (v[r].v + c);
            if (sign((d - a) ^ (b - a)) > 0) {
                if (v[rep].type == 1) {
                    triangle_id_m[v[rep].id] = v[l].id;
                    chose[v[l].id].push_back(v[rep].v + c);
                } else {
                    throw std::runtime_error("invalid gen_query_random_smart sorting points to triangles");
                }
            }
            rep++;
            if (rep == z) rep = 0;
        }

        if (l > r) break;
        l = r;
    }
    char st = '0';
    if (parse.count("start_mode"))
        st = parse["start_mode"][0];
    if (st == '1') {
        for (int i = 0; i < hull.size(); i++)
            for (auto j: chose[i]) {
                if (j.x == 1488228 || j.y == 1488228)
                    throw std::runtime_error("invalid point 1488228 in cluster queries");
                before.push_back(j);
            }
    }
    string last(hull.size(), st);
    int mx = 1 << 30;
    if (parse.count("period"))
        mx = num(parse["period"]);
    while (qs.size() < q) {
        string now = last;
        if (rnd.next(0, 1) == 1 && bob.size() > 1) { // is bob_sequence
            now = bob[rnd.next(0, (int) bob.size() - 1)];
        } else {
            for (int i = 0; i < now.size();) {
                int rem = now.size() - i;
                rem = min(rem, mx);
                int len = rnd.next(1, rem);
                int value = rnd.next(0, 1);
                for (int j = i; j < i + len; j++)
                    now[j] = '0' + value;
                i += len;
            }
        }
        if (now == last) continue;
        for (int i = 0; i < now.size() && qs.size() < q; i++) {
            if (now[i] != last[i]) {
                if (now[i] == '1') {
                    for (auto j: chose[i])
                        if(qs.size() < q)
                            qs.push_back({j, '+'});
                } else {
                    for (auto j: chose[i])
                        if(qs.size() < q)
                            qs.push_back({j, '-'});
                }
            }
        }
        last = now;
    }
}


signed main(int argc, char *argv[]) {
//    ::freopen("input.txt", "r", stdin);
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string cur = argv[i];
        int p = find(cur.begin(), cur.end(), '=') - cur.begin();
        parse[cur.substr(0, p)] = cur.substr(p + 1, (int) cur.size() - p);
    }
    vector<point> hull;
    vector<point> in;
    int n = 5, c = 1e5, dif = 5;
    if (parse.count("n"))
        n = num(parse["n"]);
    if (parse.count("c"))
        c = num(parse["c"]);
    if (parse.count("dif"))
        dif = num(parse["dif"]);
    if (parse["mode"] == "torus") {
        hull = CreateTorusPoints(n, c);
        build_convex_hull_from_points(hull, in);
    }
    if (parse["mode"] == "hyperbola") {
        hull = CreateBigHullPoints(n, c);
        build_convex_hull_from_points(hull, in);
    }
    if (parse["mode"] == "grid") {
        string heavy_mode = "light";
        if (parse.count("heavy_mode"))
            heavy_mode = parse["heavy_mode"];
        hull = CreateGridPoints(n, c, 0, 0);
        if (heavy_mode == "heavy") build_convex_hull_from_points_with_line(hull, in);
        else build_convex_hull_from_points(hull, in);
    }
    if (parse["mode"] == "triangle") {
        int stat = 0;
        if (parse["triangle_mode"] == "static")
            stat = 1;
        hull = CreateTrianglesPoints(n, c, stat);
        build_convex_hull_from_points(hull, in);
    }
    if (parse["mode"] == "random") {
        hull = CreateRandomPoints(n, c);
        build_convex_hull_from_points(hull, in);
    }
    if (parse["mode"] == "wtf") {
        hull = CreatePolygonPoints(n, c);
        build_convex_hull_from_points(hull, in);
    }
    if (parse["mode"] == "regular") {
        int rad = 10;
        if (parse.count("rad")) rad = num(parse["rad"]);
        hull = gen_regular_polygon(n, rad);
        build_convex_hull_from_points(hull, in);
    }
    point central;
    if (parse["mode"] != "grid") {
        gen_internal_points(hull, in, 1);
        central = in[0];
        fix_points(hull, central, in);
        string internal_mode = "random";
        if (parse.count("internal_mode")) {
            internal_mode = parse["internal_mode"];
        }
        if (internal_mode == "random") {
            gen_internal_points(hull, in, dif);
            while (in.size() < dif) {
//                 err(in.size());
                gen_internal_points(hull, in, dif);
                fix_points(hull, central, in);
            }
        } else if (internal_mode == "each_one") {
            gen_internal_points_each_part_center(central, hull, in);
        } else if (internal_mode == "each_one_cluster") {
            gen_internal_points_each_part_center_cluster(central, hull, in);
        }
    } else {
        in.clear();
        gen_internal_points_for_grid(hull, in, 1, c);
        central = in[0];
        fix_points(hull, central, in);
        string internal_mode = "random";
        if (parse.count("internal_mode")) {
            internal_mode = parse["internal_mode"];
        }
        if (internal_mode == "random") {
            gen_internal_points_for_grid(hull, in, dif, c);
            while (in.size() < dif) {
//                err(in.size());
                gen_internal_points_for_grid(hull, in, dif, c);
                fix_points(hull, central, in);
            }
        } else if (internal_mode == "each_one") {
            gen_internal_points_each_part_center(central, hull, in);
        } else if (internal_mode == "each_one_cluster") {
            gen_internal_points_each_part_center_cluster(central, hull, in);
        }
    }
    vector<point> before;
    vector<query> qs;
    int m = 10, q = 10;
    if (parse.count("m"))
        m = num(parse["m"]);
    if (parse.count("q"))
        q = num(parse["q"]);
    string query_mode = "random";
    if (parse.count("query_mode")) {
        query_mode = parse["query_mode"];
    }
    if (query_mode == "random") {
        gen_query_rand(in, before, qs, m, q);
    } else if (query_mode == "all") {
        gen_query_all(in, before, qs, m);
    } else if (query_mode == "random_smart") {
        gen_query_random_smart(central, hull, in, before, qs, q);
    } else if (query_mode == "random_smart_cluster") {
        gen_query_random_smart_cluster(central, hull, in, before, qs, q);
    } else {
        ensuref(false, "TODO query_mode");
//        calc_dp();
    }
    cout << hull.size() << ' ' << before.size() << ' ' << qs.size() << '\n';
    cout << central.x << ' ' << central.y << '\n';
    for (auto i: hull) {
        ensuref(i.x != 1488288 && i.y != 1488288, "1488228 point");
        cout << i.x << ' ' << i.y << '\n';
    }
    for (auto i: before) {
        ensuref(i.x != 1488288 && i.y != 1488288, "1488228 point");
        cout << i.x << ' ' << i.y << '\n';
    }
    for (auto i: qs) {
        ensuref(i.pt.x != 1488288 && i.pt.y != 1488288, "1488228 point");
        cout << i.type << ' ' << i.pt.x << ' ' << i.pt.y << '\n';
    }
}
