#include "bits/stdc++.h"

#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define all(a) a.begin(), a.end()
#define pb push_back
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }


/// Actual code starts here
const int N = 5005;
const long double EPS = 1e-6;
const long double PI = acosl(-1);

int sign(ll x) {
    if (x == 0) return 0;
    return (x < 0 ? -1 : 1);
}

int sign(ld x) {
    if (x > EPS) {
        return 1;
    } else if (x < -EPS) {
        return -1;
    } else {
        return 0;
    }
}

ll sq(ll a) {
    return a * a;
}

ld sq(ld a) {
    return a * a;
}

#define vec point

struct point {
    ll x = 0, y = 0;

    point operator+(const point &other) const {
        return point({x + other.x, y + other.y});
    }

    point operator-(const point &other) const {
        return point({x - other.x, y - other.y});
    }

    point operator*(const ll &delta) const {
        return point({x * delta, y * delta});
    }

    ll operator*(const point &other) const {
        return x * other.x + y * other.y;
    }

    ll operator^(const point &other) const {
        return x * other.y - y * other.x;
    }

    bool operator<(const point &other) const {
        if (sign(x - other.x) == 0) {
            return sign(y - other.y) < 0;
        } else {
            return sign(x - other.x) < 0;
        }
    }

    bool operator==(const point &other) const {
        return sign(x - other.x) == 0 && sign(y - other.y) == 0;
    }

    point perp() const {
        return point({-y, x});
    }

    long double len() const {
        return sqrtl(sq(x) + sq(y));
    }

    long long len2() const {
        return sq(x) + sq(y);
    }

    friend std::ostream &operator<<(std::ostream &os, const point &p) {
        os << "[x, y]: " << fixed << p.x << ' ' << p.y;
        return os;
    }
};


bool on_segment(const point &a, const point &b, const point &c) {
    if (a == c || b == c) return true;
    if (a == b) return false;
    return sign((c - a) ^ (b - a)) == 0 && sign((c - a) * (b - a)) == 1 && sign((c - b) * (a - b)) == 1;
}


point c;

bool check(int id, vector<point> &hull, vector<point> &pts) {
    vector<int> in(pts.size()), in2(pts.size());
    for (int i = 0; i < pts.size(); i++) {
        ld sum = 0;
        int ok = 0;
        for (int j = 0; j < hull.size(); j++) {
            vec a = hull[(j + 1) % hull.size()] - pts[i];
            vec b = hull[j] - pts[i];
            if (on_segment(hull[j], hull[(j + 1) % hull.size()], pts[i])) {
                ok = 1;
            }
            sum += ::atan2(a ^ b, a * b);
        }
        if (ok || sign(sum - 2 * PI) == 0 || sign(sum + 2 * PI) == 0) {
            in[i] = 1;
        }
    }
    vec rep = hull[id];
    hull[id] = c;
    for (int i = 0; i < pts.size(); i++) {
        ld sum = 0;
        int ok = 0;
        for (int j = 0; j < hull.size(); j++) {
            vec a = hull[(j + 1) % hull.size()] - pts[i];
            vec b = hull[j] - pts[i];
            if (on_segment(hull[j], hull[(j + 1) % hull.size()], pts[i])) {
                ok = 1;
            }
            sum += ::atan2(a ^ b, a * b);
        }
        if (ok || sign(sum - 2 * PI) == 0 || sign(sum + 2 * PI) == 0) {
            in2[i] = 1;
        }
    }

    int ok = 0;
    for (int i = 0; i < pts.size(); i++)
        ok |= (in[i] != in2[i]);
    hull[id] = rep;

    return ok;
}

int go(vector<point> hull, vector<point> &pts) {
    int res = 0;
    for (int i = 0; i < hull.size() && !res; i++) {
        if (hull[i] == c) continue;
        if (check(i, hull, pts)) {
            vec rep = hull[i];
            hull[i] = c;
            res |= go(hull, pts) ^ 1;
            hull[i] = rep;
        }
    }
    return res;
}


void solve() {
    int n, m, q;
    cin >> n >> m >> q >> c.x >> c.y;
    vector<point> hull(n);
    vector<point> pts(m);
    multiset<point> st;
    for (auto &[x, y]: hull) cin >> x >> y;
    for (auto &[x, y]: pts) cin >> x >> y;
    for (int i = 0; i < pts.size(); i++) {
        st.insert(pts[i]);
    }
    if (go(hull, pts)) {
        cout << "Alice\n";
    } else {
        cout << "Bob\n";
    }
    for (int i = 0; i < q; i++) {
        char s;
        point pt;
        cin >> s >> pt.x >> pt.y;
        if (s == '+') {
            st.insert(pt);
        } else {
            assert(st.count(pt));
            st.erase(st.find(pt));
        }
        pts.clear();
        for (auto j: st)
            pts.push_back(j);
        if (go(hull, pts)) {
            cout << "Alice\n";
        } else {
            cout << "Bob\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}



