#include "bits/stdc++.h"

#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define all(a) a.begin(), a.end()
#define pb push_back
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }


/// Actual code starts here
const int N = 10005;

int sign(ll x) {
    if (x == 0) return 0;
    return (x < 0 ? -1 : 1);
}

ll sq(ll a) {
    return a * a;
}

#define vec point

struct point {
    ll x = 0, y = 0;

    point operator+(const point &other) const {
        return point({x + other.x, y + other.y});
    }

    point operator-(const point &other) const {
        return point({x - other.x, y - other.y});
    }

    point operator*(const ll &delta) const {
        return point({x * delta, y * delta});
    }

    ll operator*(const point &other) const {
        return x * other.x + y * other.y;
    }

    ll operator^(const point &other) const {
        return x * other.y - y * other.x;
    }

    bool operator<(const point &other) const {
        if (sign(x - other.x) == 0) {
            return sign(y - other.y) < 0;
        } else {
            return sign(x - other.x) < 0;
        }
    }

    bool operator==(const point &other) const {
        return sign(x - other.x) == 0 && sign(y - other.y) == 0;
    }

    friend std::ostream &operator<<(std::ostream &os, const point &p) {
        os << "[x, y]: " << fixed << p.x << ' ' << p.y;
        return os;
    }
};

int dp[N];
int mex[N], use[N];
int T = 1;

int get_mex(int n) {
    T++;
    int pt = 0;
    for (int i = 0; i < n; i++) {
        use[mex[i]] = T;
        while (use[pt] == T) pt++;
    }
    return pt;
}


void calc_dp() {
    dp[0] = 0;
    dp[1] = 1;
    for (int len = 2; len < N; len++) {
        int pt = 0;
        mex[pt++] = dp[len - 1];
        mex[pt++] = dp[len - 2];
        for (int cut = 1; cut + 2 < len; cut++) {
            mex[pt++] = (dp[cut] ^ dp[len - cut - 2]);
        }
        dp[len] = get_mex(pt);
    }
}

int cnt[N], ok[N];

void add(int p) {
    cnt[p]++;
    if (cnt[p] == 1) {
        ok[p] = 1;
    }
}

void sub(int p) {
    cnt[p]--;
    if (cnt[p] == 0) {
        ok[p] = 0;
    }
}

int calc(int n) {
    if (count(ok, ok + n, 1) == n) return 1 ^ min(1, dp[n - 2]);
    int res = 0;
    for (int i = 0; i < n;) {
        if (ok[i] == 0) {
            i++;
            continue;
        }
        int j = i;
        while (ok[j % n] != 0) j++;
        res ^= dp[j - i];
        if (j >= n) res ^= dp[j - n];
        i = j;
    }
    return res;
}


void print(int res) {
    if (min(res, 1)) {
        cout << "Alice\n";
    } else {
        cout << "Bob\n";
    }
}

bool in_hull(vector<point> &hull, point pt) {
    int okis = 0;
    for (int i = 0; i < hull.size(); i++) {
        vec a = hull[(i + 1) % hull.size()] - hull[i];
        if (sign(a ^ (pt - hull[i])) == 1) {
            okis |= 1;
        } else if (sign(a ^ (pt - hull[i])) == -1) {
            okis |= 2;
        } else {
            okis |= 3;
        }
    }
    return okis != 3;
}

bool in_triangle(point a, point b, point c, point fc) {
    vector<point> pt = {a, b, c};
    return in_hull(pt, fc);
}

int get_id(point pt, vector<point> &hull, point c) {
    for (int i = 0; i < hull.size(); i++) {
        point a = hull[i];
        point b = hull[(i + 1) % hull.size()];
        if (in_triangle(a, b, c, pt)) return i;
    }
    assert(false);
}


void solve() {
    calc_dp();
    int n, m, q;
    point c;
    cin >> n >> m >> q >> c.x >> c.y;
    vector<point> hull(n);
    vector<point> pts(m);
    for (auto &[x, y]: hull) cin >> x >> y;
    for (auto &[x, y]: pts) cin >> x >> y;
    for (auto i: pts) {
        int id = get_id(i, hull, c);
        add(id);
    }
    print(calc(hull.size()));
    for (int i = 0; i < q; i++) {
        char s;
        point pt;
        cin >> s >> pt.x >> pt.y;
        int id = get_id(pt, hull, c);
        if (s == '-') {
            sub(id);
        } else {
            add(id);
        }
        print(calc(hull.size()));
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
