#include "bits/stdc++.h"

#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define all(a) a.begin(), a.end()
#define pb push_back
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }


/// Actual code starts here
const int N = 10005;

int sign(ll x) {
    if (x == 0) return 0;
    return (x < 0 ? -1 : 1);
}

ll sq(ll a) {
    return a * a;
}

ld sq(ld a) {
    return a * a;
}

#define vec point

struct point {
    ll x = 0, y = 0;

    point operator+(const point &other) const {
        return point({x + other.x, y + other.y});
    }

    point operator-(const point &other) const {
        return point({x - other.x, y - other.y});
    }

    point operator*(const ll &delta) const {
        return point({x * delta, y * delta});
    }

    ll operator*(const point &other) const {
        return x * other.x + y * other.y;
    }

    ll operator^(const point &other) const {
        return x * other.y - y * other.x;
    }

    bool operator<(const point &other) const {
        if (sign(x - other.x) == 0) {
            return sign(y - other.y) < 0;
        } else {
            return sign(x - other.x) < 0;
        }
    }

    bool operator==(const point &other) const {
        return sign(x - other.x) == 0 && sign(y - other.y) == 0;
    }

    point perp() const {
        return point({-y, x});
    }

    long double len() const {
        return sqrtl(sq(x) + sq(y));
    }

    long long len2() const {
        return sq(x) + sq(y);
    }

    friend std::ostream &operator<<(std::ostream &os, const point &p) {
        os << "[x, y]: " << fixed << p.x << ' ' << p.y;
        return os;
    }
};

struct vec_info {
    vec v;
    int type; // from triangle or from points
    int id;
};


int dp[N];
int mex[N];


int get_mex(int n) {
    for (int i = 0; i < n; i++) {
        while (true) {
            if (mex[i] >= n || mex[i] < 0) break;
            if (mex[mex[i]] == mex[i]) break;
            swap(mex[i], mex[mex[i]]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (mex[i] != i)
            return i;
    }
    return n;
}


bool cmp(const vec_info &a, const vec_info &b) {
    int s = sign(a.v ^ b.v);
    if (s > 0) return true;
    else if (s == 0) return a.v.len2() < b.v.len2();
    else return false;
}

void sorting(vector<vec_info> &vectors) {
    vector<vec_info> up, dw;
    for (auto &v: vectors) {
        if (v.v.y > 0 || (v.v.y >= 0 && v.v.x >= 0)) {
            up.push_back(v);
        } else {
            dw.push_back(v);
        }
    }

    sort(up.begin(), up.end(), cmp);
    sort(dw.begin(), dw.end(), cmp);
    for (auto &i: dw) {
        up.push_back(i);
    }
    vectors = up;
}

void calc_dp() {
    dp[0] = 0;
    dp[1] = 1;
    for (int len = 2; len < N; len++) {
        int pt = 0;
        mex[pt++] = dp[len - 1];
        mex[pt++] = dp[len - 2];
        for (int cut = 1; cut + 2 < len; cut++) {
            mex[pt++] = (dp[cut] ^ dp[len - cut - 2]);
        }
        dp[len] = get_mex(pt);
    }
}

int cnt[2000000];
int ok[2000000];

void add(int p) {
    cnt[p]++;
    if (cnt[p] == 1) {
        ok[p] = 1;
    }
}

void sub(int p) {
    cnt[p]--;
    if (cnt[p] == 0) {
        ok[p] = 0;
    }
}

void print(int res) {
    if (min(res, 1)) {
        cout << "Alice\n";
    } else {
        cout << "Bob\n";
    }
}

void calc(vector<point> &hull, vector<point> &pts, point c) {
    int n = hull.size();
    int m = pts.size();
    for (int i = 0; i < n + m; i++) cnt[i] = 0, ok[i] = 0;
    vector<vec_info> v;
    for (int i = 0; i < n; i++) {
        v.push_back({hull[i] - c, 0, i});
    }
    sorting(v);
    for (int i = 0; i < n; i++) {
        v[i].id = i;
    }

    for (int i = 0; i < m; i++) {
        v.push_back({pts[i] - c, 1, i});
    }
    sorting(v);

    vector<int> triangle_id(m, -1);
    int z = v.size();
    int l = 0;

    while (v[l].type == 1) l++;
    while (l < z) {
        int r = (l + 1) % z;
        while (v[r].type == 1) {
            r++;
            if (r == z) r = 0;
        }

        int rep = (l + 1) % z;
        while (rep != r) {
            point a = (v[l].v + c);
            point b = (v[rep].v + c);
            point d = (v[r].v + c);
            if (sign((d - a) ^ (b - a)) > 0) {
                triangle_id[v[rep].id] = v[l].id;
            }
            rep++;
            if (rep == z) rep = 0;
        }

        if (l > r) break;
        l = r;
    }
//    errv(triangle_id);
    for (int i = 0; i < m; i++) {
        if (triangle_id[i] != -1)
            add(triangle_id[i]);
    }

    if (count(ok, ok + n, 1) == n) {
        int value = 1 ^ min(1, dp[n - 2]);
        print(1 ^ min(1, dp[n - 2]));
    } else {
        int ps = find(ok, ok + n, 0) - ok;
        rotate(ok, ok + ps, ok + n);
        int res = 0;
        for (int i = 0; i < n;) {
            if (ok[i] == 0) {
                i++;
                continue;
            }
            int j = i;
            while (j < n && ok[j]) j++;
            res ^= dp[j - i];
            i = j;
        }
        print(res);
    }
}

void solve() {
    calc_dp();
    int n, m, q;
    point c;
    cin >> n >> m >> q >> c.x >> c.y;
    vector<point> hull(n);
    vector<point> pts(m);
    multiset<point> st;
    for (auto &[x, y]: hull) cin >> x >> y;
    for (auto &[x, y]: pts) cin >> x >> y;
    for (int i = 0; i < pts.size(); i++) {
        st.insert(pts[i]);
    }
    calc(hull, pts, c);
    for (int i = 0; i < q; i++) {
        char s;
        point pt;
        cin >> s >> pt.x >> pt.y;
        if (s == '+') {
            st.insert(pt);
        } else {
            assert(st.count(pt));
            st.erase(st.find(pt));
        }
        pts.clear();
        for (auto j: st)
            pts.push_back(j);
        calc(hull, pts, c);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
