#include "bits/stdc++.h"

#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define all(a) a.begin(), a.end()
#define pb push_back
typedef long long ll;
typedef long double ld;
using namespace std;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; }


/// Actual code starts here
const int N = 10005;

int sign(ll x) {
    if (x == 0) return 0;
    return (x < 0 ? -1 : 1);
}

ll sq(ll a) {
    return a * a;
}

#define vec point

struct point {
    int x = 0, y = 0;

    point operator+(const point &other) const {
        return point({x + other.x, y + other.y});
    }

    point operator-(const point &other) const {
        return point({x - other.x, y - other.y});
    }

    ll operator*(const point &other) const {
        return 1ll * x * other.x + 1ll * y * other.y;
    }

    ll operator^(const point &other) const {
        return 1ll * x * other.y - 1ll * y * other.x;
    }

    bool operator<(const point &other) const {
        if (sign(x - other.x) == 0) {
            return sign(y - other.y) < 0;
        } else {
            return sign(x - other.x) < 0;
        }
    }

    bool operator==(const point &other) const {
        return sign(x - other.x) == 0 && sign(y - other.y) == 0;
    }

    point perp() const {
        return point({-y, x});
    }

    long double len() const {
        return sqrtl(sq(x) + sq(y));
    }

    long long len2() const {
        return sq(x) + sq(y);
    }

    friend std::ostream &operator<<(std::ostream &os, const point &p) {
        os << "[x, y]: " << fixed << p.x << ' ' << p.y;
        return os;
    }
};

struct vec_info {
    vec v;
    int type; // from triangle or from points
    int id;
};

struct query {
    int t;
    point p;
};


int dp[N];
int T = 1;
int mex[N], use[N];
int cnt[N];
int ok[N];


int get_mex(int n) {
    T++;
    int pt = 0;
    for (int i = 0; i < n; i++) {
        use[mex[i]] = T;
        while (use[pt] == T) pt++;
    }
    return pt;
}


bool cmp(const vec_info &a, const vec_info &b) {
    int s = sign(a.v ^ b.v);
    if (s > 0) return true;
    else if (s == 0) return a.v.len2() < b.v.len2();
    else return false;
}

void sorting(vector<vec_info> &vectors) {
    vector<vec_info> up, dw;
    for (auto &v: vectors) {
        if (v.v.y > 0 || (v.v.y >= 0 && v.v.x >= 0)) {
            up.push_back(v);
        } else {
            dw.push_back(v);
        }
    }

    sort(up.begin(), up.end(), cmp);
    sort(dw.begin(), dw.end(), cmp);
    for (auto &i: dw) {
        up.push_back(i);
    }
    vectors = up;
}

void calc_dp() {
    dp[0] = 0;
    dp[1] = 1;
    for (int len = 2; len < N; len++) {
        int pt = 0;
        mex[pt++] = dp[len - 1];
        mex[pt++] = dp[len - 2];
        for (int cut = 1; cut + 2 < len; cut++) {
            mex[pt++] = (dp[cut] ^ dp[len - cut - 2]);
        }
        dp[len] = get_mex(pt);
    }
}

int cntal = 0;

void add(int p, int n) {
    cnt[p]++;
    if (cnt[p] == 1) {
        cntal++;
        ok[p] = 1;
    }
}

void sub(int p, int n) {
    cnt[p]--;
    if (cnt[p] == 0) {
        cntal--;
        ok[p] = 0;
    }
}

void print(int res) {
    int value = min(res, 1);
    if (value == 1) {
        cout << "Alice\n";
    } else {
        cout << "Bob\n";
    }
}

int get_gr(int n) {
    if (cntal == n) {
        return 1 ^ min(1, dp[n - 2]);
    }
    int res = 0;
    for (int i = 0; i < n;) {
        if (ok[i] == 0) {
            i++;
            continue;
        }
        int j = i;
        while (ok[(j >= n ? j - n : j)] != 0) {
            j++;
        }
        res ^= dp[j - i];
        if (j >= n) res ^= dp[j - n];
        i = j;
    }
    return res;
}

void solve() {
    int n, m, q;
    point c;
    cin >> n >> m >> q >> c.x >> c.y;
    vector<point> hull(n);
    vector<point> pts(m);
    vector<query> qs(q);
    for (auto &[x, y]: hull) cin >> x >> y;
    for (auto &[x, y]: pts) cin >> x >> y;
    for (int i = 0; i < q; i++) {
        char s;
        point pt;
        cin >> s >> pt.x >> pt.y;
        if (s == '+') {
            qs[i] = {1, pt};
        } else {
            qs[i] = {-1, pt};
        }
    }

    vector<vec_info> v;
    for (int i = 0; i < n; i++) {
        v.push_back({hull[i] - c, 0, i});
    }
    sorting(v);
    for (int i = 0; i < n; i++) {
        v[i].id = i;
    }

    for (int i = 0; i < m; i++) {
        v.push_back({pts[i] - c, 1, i});
    }

    for (int i = 0; i < q; i++) {
        v.push_back({qs[i].p - c, 2, i});
    }

    sorting(v);

    vector<int> triangle_id_m(m, -1);
    vector<int> triangle_id_q(q, -1);

    int z = v.size();
    int l = 0;

    while (v[l].type != 0) l++;
    while (l < z) {
        int r = (l + 1) % z;
        while (v[r].type != 0) {
            r++;
            if (r == z) r = 0;
        }

        int rep = (l + 1) % z;
        while (rep != r) {
            point a = (v[l].v + c);
            point b = (v[rep].v + c);
            point d = (v[r].v + c);
            if (v[rep].type == 1) {
                triangle_id_m[v[rep].id] = v[l].id;
            } else if (v[rep].type == 2) {
                triangle_id_q[v[rep].id] = v[l].id;
            } else {
                assert(false);
            }
            rep++;
            if (rep == z) rep = 0;
        }

        if (l > r) break;
        l = r;
    }
    calc_dp();
    for (int i = 0; i < m; i++) {
        if (triangle_id_m[i] != -1)
            add(triangle_id_m[i], n);
    }
    print(get_gr(n));
    for (int i = 0; i < q; i++) {
        if (qs[i].t == 1) {
            add(triangle_id_q[i], n);
        } else {
            sub(triangle_id_q[i], n);
        }
        print(get_gr(n));
    }

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
